#define _CRT_SECURE_NO_WARNINGS
#include "epm_handler_common.h"

int ML_ChangeStatus(EPM_action_message_t msg)
{
	printf("=========================更改生命周期状态 Start===================\n");
	auto startTime = std::chrono::high_resolution_clock::now();
	int ifail = ITK_ok;
	int  attachments_num = 0;
	tag_t  rootTask = NULLTAG, *attachments = NULLTAG;
	//获取任务对象
	EPM_ask_root_task(msg.task, &rootTask);
	//获取任务目标对象
	EPM_ask_attachments(rootTask, EPM_target_attachment, &attachments_num, &attachments);

	char *argflag = NULL, *argvalue = NULL, *arg = NULL;
	char arg1value[1024] = "", arg2value[1024] = "", arg3value[1024] = "", arg4value[1024] = "";
	//获取参数
	int arg_cnt = TC_number_of_arguments(msg.arguments);
	printf("参数个数为：%d\n", arg_cnt);
	if (arg_cnt > 0)
	{
		for (int i = 0; i<arg_cnt; i++)
		{
			//获取下一个参数（从0开始）
			arg = TC_next_argument(msg.arguments);
			//获取参数的名称和值
			ifail = ITK_ask_argument_named_value((const char*)arg, &argflag, &argvalue);
			if (stricmp(argflag, "referenced") == 0)
			{
				//strcmp("","");
				if (argvalue != NULL)
				{
					strcpy(arg1value, argvalue);
				}
			}
			else if(stricmp(argflag, "referencedItemType") == 0)
			{
				//strcmp("","");
				if (argvalue != NULL)
				{
					strcpy(arg4value, argvalue);
				}
			}
			else if (stricmp(argflag, "processName") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(arg2value, argvalue);
				}
			}
			else if (stricmp(argflag, "itemType") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(arg3value, argvalue);
				}
			}
		}
	}

	vector<char *> referencedItemTypes;

	if (strstr(arg4value, ",") != NULL)
	{
		int vectorValueCount = 0;
		char ** vectorValueChar = new char *[64];
		split(arg4value, ",", vectorValueChar, &vectorValueCount);
		for (int i = 0; i < vectorValueCount; i++)
		{
			referencedItemTypes.push_back(vectorValueChar[i]);
		}
	}
	else
	{
		referencedItemTypes.push_back(arg4value);
	}
	POM_AM__set_application_bypass(true);

	for (int i = 0; i < attachments_num; i++)
	{
		char *itemType = NULL;

		AOM_ask_value_string(attachments[i], "object_type", &itemType);
		printf("type_class : %s \r\n", itemType);
		//过滤掉非版本的对象
		if ((strcmp(itemType, arg3value) != NULL))
		{
			DOFREE(itemType);
			continue;
		}

		int num = 0;
		tag_t * value = NULLTAG;
		AOM_ask_value_tags(attachments[i], arg1value, &num, &value);

		tag_t template_tag = NULLTAG;
		EPM_find_template2(arg2value, PROCESS_TEMPLATE, &template_tag);

		int size = 0;
		tag_t new_process = NULLTAG;
		int *tagType = (int *)MEM_alloc(1024 * sizeof(int));//EPM_reference_attachment
		tag_t * itemTag = (tag_t *)MEM_alloc(1024 * sizeof(tag_t));
		for (int j = 0; j < num; j++)
		{
			char *objectType = NULL;

			AOM_ask_value_string(value[j], "object_type", &objectType);
			//过滤掉非版本的对象
			if (!count(referencedItemTypes, objectType) && strcmp(arg4value, "") != 0)
			{
				DOFREE(objectType);
				continue;
			}
			tagType[size] = EPM_target_attachment;
			itemTag[size] = value[j];
			size = size + 1;
			DOFREE(objectType);
		}
		printf("发起流程 Start===================\n");
		EPM_create_process("更改生命周期状态", "", template_tag, size, itemTag, tagType, &new_process);
		printf("发起流程 End===================\n");
		for (int j = 0; j < size; j++)
		{
			AOM_lock(itemTag[j]);
			AOM_save(itemTag[j]);
			AOM_unlock(itemTag[j]);
			AOM_refresh(itemTag[j], false);
		}
		printf("刷新对象 End===================\n");
		DOFREE(value);
		DOFREE(itemType);
		printf("释放内存 End===================\n");
	}
	POM_AM__set_application_bypass(false);
	DOFREE(attachments);

	auto stopTime = std::chrono::high_resolution_clock::now();
	auto duration = std::chrono::duration_cast<std::chrono::microseconds>(stopTime - startTime);
	//std::cout << "ML_ChangeStatus用时:" << duration.count() / 1000 << std::endl;
	string usetime = "ML_ChangeStatus用时:";
	usetime.append(std::to_string(duration.count() / 1000));
	WriteLog(true, usetime.c_str());
	printf("=========================更改生命周期状态 End===================\n");
	return ifail;
}